package com.huiju.welcome.service;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.huiju.welcome.model.*;

import java.util.List;
import java.util.Map;
/**
 * <p>
 *  服务类
 * </p>
 *
 * @author jobob
 * @since 2019-06-12
 */
public interface ITaCustomerService extends IService<TaCustomer> {
    List<TaPerson> getGroup(Integer customerId);

    Map<String, Object> getLastVisitInfo(Integer customerId);

    void judgeNewCust(TaPerson taPerson) throws Exception;

    void deleteCustOfPerson(Integer personId, Integer realId);

    List<TaCustomer> getSomeCustMayBe(String plateNumber);

    TaCustomer newCustByCarDevice(TaCarRecord taCarRecord, TaVisitorAppointment ...taVisitorAppointment);

    void notifyConsultant(TaCustomer taCustomer) throws Exception;

    boolean updateConsultant(TaCustomer taCustomer, Integer consultantId);

    TaCustomer newCustByMainUsher(TaMainUsherRecord taMainUsherRecord, boolean notify) throws Exception;

    Map<String, Object> getHistoryRecBy(Map<String,Object> filters);

    TaCustomer getSameByPerson(Integer personId);

    boolean updataByCarRecord(TaCustomer taCustomer, TaCarRecord taCarRecord);

    TaCustomer getByPhoneOrPlate(String phone, String plateNumber);

    TaCustomer getWithLastVisit(Integer id);

    IPage<TaCustomer> getCustomerListOfFront(int pageNumber, int pageSize, Integer consultantId, String nameOrPhone);

    List<CustomerExcel> getCustomersEqualCustomerPage(String customerName, String phone, String platNumber, Integer agentUserId);
	
	IPage<TaCustomer> getAttributionList(int pageNumber, int pageSize);
    
    IPage<TaCustomer> getUnattributionList(int pageNumber, int pageSize);

    boolean updateByMainUsher(Integer customerId, JSONObject params);
}
