package com.huiju.welcome.utils;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.io.File;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;

@Component
@ConfigurationProperties(prefix = "file")
public class XFYun {

    private Logger log = LoggerFactory.getLogger(XFYun.class);

    private String fileDir = "audio" + File.separator;

    @Value("${xfyun.huijuapi}")
    private String webapi;

    @Value("${huiju.files}")
    private String filePath;

    public String voice(String text, Integer sex) {
        String voiceName = sex == 2 ? "f" : "m";
        String url = webapi + "?t="+ Encrypt.urlEncode(text) +"&u=" + voiceName;

        return "/local?ext=mp3&url=" + Encrypt.urlEncode(url);
//        String fname = getFileName(text, sex);
//        String noPreFname = File.separator + fileDir + fname;
//        String voiceFile = filePath + fileDir + fname;
//
//        File audio = new File(voiceFile);
//        // 如果音频已经存在, 则不去调用科大讯飞接口
//        if (audio.exists()) {
//            return noPreFname;
//        } else {
//            if (!rqeustTTSFile(text, sex)) {
//                return "";
//            }
//        }
//
//        return noPreFname;
    }

    public boolean rqeustTTSFile(String text, Integer sex) {
        // 组装参数
        String voiceName = sex == 2 ? "f" : "m";
        String url = webapi + "?t="+ Encrypt.urlEncode(text) +"&u=" + voiceName;

        log.info("=============请求语音============");
        log.info(url);

        try {
            URL realUrl = new URL(url);
            HttpURLConnection httpURLConnection = (HttpURLConnection) realUrl.openConnection();
            httpURLConnection.setDoOutput(true);
            httpURLConnection.setDoInput(true);

            String cttType = httpURLConnection.getHeaderField("Content-Type");
            InputStream result = httpURLConnection.getInputStream();
            // 说明请求成功
            if (result.available() > 8) {
                FileUtil.save(filePath + fileDir, getFileName(text, sex), FileUtil.inputStream2ByteArray(result));
                return true;
            } else {
                log.error("=============请求科大讯飞语音失败============");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return false;
    }

    private String getFileName(String text, Integer sex) {
        String sexStr = sex == 2 ? "female" : "male";
        String ext =".mp3";
        return Encrypt.md5(text + "-" + sexStr) + ext;
    }
}
